{-# LINE 95 "Contract.lhs" #-}
  {-#  OPTIONS -fglasgow-exts  #-}
  module Contract
  where
  import qualified Data.List
  -- import Control.Monad
  import List hiding (foldr, sort,insert) --  (sort,sortBy,insert,insertBy)
  import Prelude hiding (id, foldr)
  import Blame --  our blame assignment
  -- import SimpleBlame -- Findler&Felleisen blame assignment
 
  default (Int)
  
  infixr 9 `o`
  f `o` g  =  \a -> f (g a)
 
  less3 a x b  =  a <= x && x < b
 
  sq x = x * x
 
  bag  x = Data.List.sort x
  sort x = Data.List.sort x
{-# LINE 259 "Contract.lhs" #-}
  nat  ::  Contract Int
  nat  =   Prop(\  i ->  i >= 0)
{-# LINE 265 "Contract.lhs" #-}
  nonempty  ::  Contract [aT]
  nonempty  =   Prop(\  x ->  not (null x))
{-# LINE 270 "Contract.lhs" #-}
  false, true  ::  Contract aT
  false  =  Prop(\  x ->  False)
  true   =  Prop(\  x ->  True)
{-# LINE 424 "Contract.lhs" #-}
  head'  ::  [aT] :-> aT
  head'  =   assert "head" (nonempty >-> true) (fun(\  x ->  (head x)))
{-# LINE 459 "Contract.lhs" #-}
  isqrt    ::  Int -> Int
  isqrt n  =   loop 0 3 1
    where loop i k s  | s <= n     =  loop (i + 1) (k + 2) (s + k)
                      | otherwise  =  i
{-# LINE 467 "Contract.lhs" #-}
  isqrt'  ::  Int :-> Int
  isqrt'  =   assert  "isqrt" (Function  nat(\n-> (Prop(\  r ->  r >= 0 && less3 (sq r) n (sq (r + 1)))))) (fun(\  n ->  (isqrt n)))
{-# LINE 482 "Contract.lhs" #-}
  five, mfive :: Int
  five   =  assert "five"   nat 5
  mfive  =  assert "mfive"  nat (-5)
{-# LINE 513 "Contract.lhs" #-}
  inc, dec :: Int :-> Int
  inc  =  assert "inc" (nat >-> nat) (fun(\  n ->  (n + 1)))
  dec  =  assert "dec" (nat >-> nat) (fun(\  n ->  (n - 1)))
{-# LINE 523 "Contract.lhs" #-}
  incloc1 = 11
  incloc2 = 12
  decloc1 = 21
  decloc2 = 22
{-# LINE 565 "Contract.lhs" #-}
  codomloc0 = 30
  codomloc1 = 31
  codomloc2 = 32
{-# LINE 575 "Contract.lhs" #-}
  codom  ::  (Int :-> Int) :-> [Int]
  codom  =   assert "f" ((nat >-> nat) >-> list nat) (fun(\  f ->  [app f codomloc0 n | n <- [1 .. 9]]))
{-# LINE 601 "Contract.lhs" #-}
  gloc0 = 40
  gloc1 = 41
  gloc2 = 42
  gloc3 = 43
  gloc4 = 44
  gloc5 = 45
  gloc6 = 46
  gloc7 = 47
  gloc8 = 48
  gloc9 = 49
  gloc10 = 50
{-# LINE 629 "Contract.lhs" #-}
  g  ::  (Int :-> Int) :-> (Int :-> Int)
  g  =   assert "g" ((nat >-> nat) >-> true) (fun(\  f ->  (fun(\  x ->  (app f gloc0 x)))))
{-# LINE 664 "Contract.lhs" #-}
  g'  =  assert "g'" ((nat >-> nat) >-> true) (fun(\  f ->  f))
{-# LINE 681 "Contract.lhs" #-}
  h  ::  (Int :-> Int) :-> (Int :-> Int)
  h  =   assert "h" (true >-> (nat >-> nat)) (fun(\  f ->  f))
{-# LINE 689 "Contract.lhs" #-}
  hloc1 = 51
  hloc2 = 52
  hloc3 = 53
  hloc4 = 54
  hloc5 = 55
  hloc6 = 56
  hloc7 = 57
  hloc8 = 58
{-# LINE 881 "Contract.lhs" #-}
  {-  |positive (`o`) :: Contract aT -> Contract aT|  -}
  positive (Prop p)          =  true
  positive (Function c1 c2)  =  Function (negative c1) (\ x -> positive (c2 x))
 
  {-  |negative (`o`) :: Contract aT -> Contract aT|  -}
  negative (Prop p)          =  Prop p
  negative (Function c1 c2)  =  Function (positive c1) (\ x -> negative (c2 x))
{-# LINE 908 "Contract.lhs" #-}
  positive, negative :: Contract aT -> Contract aT
{-# LINE 933 "Contract.lhs" #-}
  infixr :->
  newtype aT :-> bT  =  Fun { apply :: Locs -> aT -> bT }
{-# LINE 965 "Contract.lhs" #-}
  assert'                                       ::  Contract aT -> (Locs -> aT -> aT)
  assert'  (Prop p)      locs   a
    =  if p a then a else error ("contract failed: " ++ blame locs)
  assert'  (Function c1 c2)  locsf  f         
    =  Fun (\ locx -> (\ x' -> (assert' (c2 x') locsf `o` apply f locx) x') `o` assert' c1 (locsf +> locx))
  assert'  (Pair c1 c2)  locs   (a1, a2)         =   (\ a1' -> (a1' , assert' (c2 a1') locs a2)) (assert' c1 locs a1)
  assert'  (List c)      locs   as               =   map (assert' c locs) as
  assert'  (And c1 c2)   locs   a                =   (assert' c2 locs `o` assert' c1 locs) a
{-# LINE 1016 "Contract.lhs" #-}
  varassert                    ::  Contract aT -> (aT :-> aT)
  varassert  (Prop p)          =   prop' p
  varassert  (Function c1 c2)  =   function (varassert c1) (varassert `o` c2)
  varassert  (Pair c1 c2)      =   pair' (varassert c1) (varassert `o` c2)
  varassert  (List c)          =   list' (varassert c)
  varassert  (And c1 c2)       =   varassert c2 <> varassert c1
 
  prop'         ::  (aT -> Bool) -> (aT :-> aT)
  prop' p       =   Fun (\ locs a -> if p a then a else error ("contract failed: " ++ blame locs))
 
  function      ::  (a1T :-> b1T) -> (b1T -> a2T :-> b2T) -> ((b1T :-> a2T) :-> (a1T :-> b2T))
  function g h  =   Fun (\ locsf f -> Fun (\ locx -> 
                      (\ x' -> (apply (h x') locsf `o` apply f locx) x') `o` apply g (locsf +> locx)))
 
  pair'         ::  (a1T :-> b1T) -> (b1T -> a2T :-> b2T) -> ((a1T, a2T) :-> (b1T, b2T))
  pair' g h     =   Fun (\ locs (a1, a2) -> (\ a1' -> (a1', apply (h a1') locs a2)) (apply g locs a1))
 
  list'         ::  (aT :-> bT) -> ([aT] :-> [bT])
  list' g       =   Fun (\ locs -> map (apply g locs))
 
  (<>)          ::  (bT :-> cT) -> (aT :-> bT) -> (aT :-> cT)
  g <> h        =   Fun (\ locs -> apply g locs `o` apply h locs)
{-# LINE 1052 "Contract.lhs" #-}
  assert s c = assert' c (makeloc (Def s)) --  note the swap of arguments
{-# LINE 1055 "Contract.lhs" #-}
  fun f        =  Fun (\ _ x -> f x)
  app f loc x  =  apply f (makeloc (App loc)) x
{-# LINE 1058 "Contract.lhs" #-}
  id        ::  aT :-> aT
  id        =   fun (\ x -> x)
{-# LINE 1061 "Contract.lhs" #-}
  data Contract aT where
    Prop      ::  (aT -> Bool) -> Contract aT
    Function  ::  Contract aT -> (aT -> Contract bT) -> Contract (aT :-> bT)
    Pair      ::  Contract aT -> (aT -> Contract bT) -> Contract (aT, bT)
    List      ::  Contract aT -> Contract [aT]
    And       ::  Contract aT -> Contract aT -> Contract aT
{-# LINE 1075 "Contract.lhs" #-}
  prop  ::  (aT -> Bool) -> Contract aT
  prop  =   Prop
 
  list = List
 
  infixr 4 >->
  pre >->   post  =  Function pre (const post)
 
  infixr 4 >>->
  pre >>->  post  =  Function pre post
 
  infixl 3 &
  (&) = And
{-# LINE 1157 "Contract.lhs" #-}
  insertionSort  ::  (Ord aT) => [aT] -> [aT]
  insertionSort  =   foldr insert [] 
 
  insert :: (Ord aT) => aT -> [aT] -> [aT]
  insert a   []                       =  [a]
  insert a1  (a2 : as)  |  a1 <= a2   =  a1 : a2 : as
                        |  otherwise  =  a2 : insert a1 as
{-# LINE 1170 "Contract.lhs" #-}
  insert'  ::  (Ord aT) => aT :-> [aT] :-> [aT]
  insert'  =   assert "insert" (true >-> ord >-> ord) (fun(\  a ->  (fun(\  x ->  (insert a x)))))
{-# LINE 1175 "Contract.lhs" #-}
  ord  ::  (Ord aT) => Contract [aT]
  ord  =   Prop(\  x ->  ordered x)
 
  ordered                 ::  (Ord aT) => [aT] -> Bool
  ordered []              =   True
  ordered [a]             =   True
  ordered (a1 : a2 : as)  =   a1 <= a2 && ordered (a2 : as)
{-# LINE 1200 "Contract.lhs" #-}
  insertionSort'  ::  (Ord aT) => [aT] :-> [aT]
  insertionSort'  =   assert "sort" (true >-> ord) (fun(\  x ->  (insertionSort x)))
{-# LINE 1213 "Contract.lhs" #-}
  preserves    ::  (Eq bT) => (aT -> bT) -> Contract (aT :-> aT)
  preserves f  =   Function  true(\x-> (Prop(\  y ->  f x == f y)))
{-# LINE 1231 "Contract.lhs" #-}
  is    ::  (Eq bT) => (aT -> bT) -> Contract (aT :-> bT)
  is f  =   Function  true(\x-> (Prop(\  y ->  y == f x)))
 
  insertionSort''  =   assert "sort" (is sort) (fun(\  x ->  (insertionSort x)))
{-# LINE 1238 "Contract.lhs" #-}
  insertionSort''  ::  (Ord aT) => [aT] :-> [aT]
{-# LINE 1279 "Contract.lhs" #-}
  comploc1 = 101
  comploc2 = 102
  foldloc1 = 111
  foldloc2 = 112
  isloc1 = 121
  isloc2 = 122
  whileloc1 = 131
  isquloc1 = 141
  isquloc2 = 142
  isquloc3 = 143
{-# LINE 1315 "Contract.lhs" #-}
  foldr                ::  (aT -> bT -> bT) -> bT -> [aT] -> bT
  foldr f e  []        =   e
  foldr f e  (a : as)  =   f a (foldr f e as)
{-# LINE 1324 "Contract.lhs" #-}
  foldr' :: Contract bT -> (aT :-> bT :-> bT) :-> bT :-> [aT] :-> bT
  foldr' inv =  assert "foldr"  ((true >-> inv >-> inv) >-> inv >-> true >-> inv) 
                                (fun(\  f ->  (fun(\  e ->  (fun(\  x ->  (foldr (\ a -> \ b -> app (app f foldloc1 a) foldloc2 b) e x)))))))
{-# LINE 1590 "Contract.lhs" #-}
  c, c1, c2 :: Contract [Int]
  c   =  c1 & c2
  c1  =  Prop(\  x ->  sum x == 0)
  c2  =  list false
{-# LINE 1596 "Contract.lhs" #-}
  c3,c4 :: Contract ([Int] :-> Int)
  c3 = Function c2 d1
  c4 = Function c1 d2
{-# LINE 1600 "Contract.lhs" #-}
  d1 = (\x -> true)
  d2 = (\x -> Prop (\y -> product x /= y))
{-# LINE 1603 "Contract.lhs" #-}
  c5 = Function (And c1 c2) (\x -> And (d1 x) (d2 x))
{-# LINE 1605 "Contract.lhs" #-}
  testlhs = app (assert "1" (And c3 c4) (Fun (\l x -> (length  x)))) 3 [-2,2]
  testrhs = app (assert "1" c5 (Fun (\l x -> (length x)))) 3  [-2,2]
{-# LINE 1694 "Contract.lhs" #-}
  ngloc1 = 201
  ngloc2 = 202
{-# LINE 1726 "Contract.lhs" #-}
  f' =  assert "f" (true >-> Prop(\  y ->  y == f y)) (fun(\  x ->  (f x)))
{-# LINE 1748 "Contract.lhs" #-}
  f = abs
{-# LINE 1932 "Contract.lhs" #-}
  c12 = ((Prop(\  n ->  n > 0)) >-> nat) >-> (nat >-> nat)
  g1, g2  ::  (Int :-> Int) :-> (Int :-> Int)
  g1  =   assert "g1" c12 (fun(\  f ->  f))
  g2  =   assert "g2" c12 (fun(\  f ->  (fun(\  x ->  (app f 0 x)))))
{-# LINE 1941 "Contract.lhs" #-}
  pos :: Contract Double
  pos = Prop(\  n ->  n > 0)
{-# LINE 1945 "Contract.lhs" #-}
  slope :: (Double -> Double) -> (Double -> Double -> Double)
  slope f a b = (f b - f a) / (b - a)
  slope' :: (Double :-> Double) :-> (Double :-> Double :-> Double)
  slope' = assert "slope"
             ((pos >-> pos) >-> (pos >-> pos >-> pos))
           (fun(\  f ->  (fun(\  a ->  (fun(\  b ->  (slope (\ n -> app f 0 n) a b)))))))
{-# LINE 1963 "Contract.lhs" #-}
  x0   ::  (((Int :-> Int) :-> Int) :-> Int)
  x0   =   assert "x0" (((nat >-> nat) >-> nat) >-> nat) (fun(\  x1 ->  (app x1 2 (fun(\  x3 ->  x3)))))
  x0'  ::  (((Int :-> Int) :-> Int) :-> Int)
  x0'  =   assert "x0" (((nat >-> nat) >-> nat) >-> nat) (fun(\  x1 ->  (app x1 2 (fun(\  x3 ->  (x3 - 1))))))
{-# LINE 1976 "Contract.lhs" #-}
  nat4  =  (((nat >-> nat) >-> nat) >-> nat) >-> nat
  y0    =  assert "y0"   nat4  (fun(\  y1 ->  (app y1 2 (fun (\ y3 -> app y3 4 1)))))
  y0'   =  assert "y0'"  nat4  (fun(\  y1 ->  (app y1 2 (fun (\ y3 -> app y3 4 (-1))))))
